/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SPKICertificateFactory
  Package: spki
  File:    SPKICertificateFactory.java
*/

package fi.hut.tcm.spki;
import java.security.cert.CertificateFactory;
import fi.hut.tcm.spki.SPKICRL;
import fi.hut.tcm.spki.SPKICertificate;
import java.util.*;
import java.security.*;
import java.io.InputStream;
// FIX: Make a Subject interface or something
import fi.hut.tcm.spki.impl.Subject;

/**
  SPKICertificateFactory
  
  SPKICertificateFactory generates SPKICertificates and SPKICRLs from
  their encoded forms and from their components.
*/
public interface SPKICertificateFactory {

  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, Tag tag);
  
  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, Subject subject, boolean delegation, Tag tag);
  
  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, byte[] subject, boolean delegation, Tag tag);
  
  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, Tag tag, Date notAfter);
  
  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, Tag tag, Date notBefore, Date notAfter);
  
  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, Tag tag, Date notBefore, Date notAfter, OnlineTest online);
  
  /**
  */
  public SPKICertificate makeCert(KeyPair issuer, PublicKey subject, boolean delegation, Tag tag, OnlineTest online);
  
  /**
  */
  public SPKICRL makeCrl(Enumeration certificates);
  
  /**
  */
  public SPKICRL makeCrl(Enumeration certificates, Date notAfter);
  
  /**
  */
  public SPKICRL makeCrl(Enumeration certificates, Date notBefore, Date notAfter);
  
} // SPKICertificateFactory

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
