/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Gte
  Package: impl
  File:    Gte.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  Gte
  
  Defines the ranges "greater than or equal" ("ge") and "greater than" ("g"
  ).
*/
public class Gte
  extends ByteString {

  /**
    Creates a Gte object with the default value "ge", greater than or equal
    .
  */
  public Gte() {
  
  //+ Gte::Gte( )
    super("ge");
  //- Gte::Gte( )
  }
  
  /**
    Creates a Gte object with the String value. Legal values are "ge" and "
    g".
  */
  public Gte(String value) {
  
  //+ Gte::Gte(String)
    super();
    try {
      setValue(value);
    } catch (SPKIException e) {
      System.err.println(e); 
    }
  //- Gte::Gte(String)
  }
  
  /**
  */
  public String toString() {
  
  //+ Gte::toString( )
    return new String(" " + getValueString() + " ");
  //- Gte::toString( )
  }
  
  /**
  */
  public boolean equals(Object other) {
  
  //+ Gte::equals(Object)
    if ((other instanceof Gte) && 
	(((Gte)other).getValueString().equals(getValueString())) && 
	(((Gte)other).getDisplayHintString().equals(getDisplayHintString())))
      return true;
    else 
      return false;
  //- Gte::equals(Object)
  }
  
  /**
  */
  public void setValue(byte[] string)
    throws SPKIException  {
  
  //+ Gte::setValue(byte[])
      String test = new String(string);
      if (test.equals("ge") || test.equals("g"))
	super.setValue(string);
      else
	throw new SPKIException("Illegal value for gte: " + string);
  //- Gte::setValue(byte[])
  }
  
  /**
  */

  public void setValue(String string)
    throws SPKIException  {
  
  //+ Gte::setValue(String)
      if (string.equals("ge") || string.equals("g"))
	super.setValue(string);
      else
	throw new SPKIException("Illegal value for gte: " + string);
  //- Gte::setValue(String)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Gte::accept(Visitor)
    visitor.at(this);
  //- Gte::accept(Visitor)
  }
  
} // Gte

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
