/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Hash
  Package: impl
  File:    Hash.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  Hash
  
  Hash should contain a HashAlgName, HashValue and an optional Uri (
  pointing to the hashed object) in that order.
*/
public class Hash
  extends Composite {

  /**
  */
  public Hash() {
  
  //+ Hash::Hash( )
    super();
  //- Hash::Hash( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ Hash::check(Component)
      if (!(addition instanceof HashAlgName) &&
	  !(addition instanceof HashValue) &&
	  !(addition instanceof Uri))
	return false;
      if ((children.size() == 0) &&
	  (addition instanceof HashAlgName))
	return true;
      if ((children.size() == 1) &&
	  (addition instanceof HashValue))
	return true;
      if ((children.size() == 2) &&
	  (addition instanceof Uri))
	return true;
      throw new IllegalStateException();
  //- Hash::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Hash::accept(Visitor)
    visitor.at(this);
  //- Hash::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ Hash::toString( )
      String result;

      result = "(hash ";
      for (int i = 0; i < size(); i++) {
	result += children.elementAt(i).toString();
	if (i < (size() - 1))
	  result += " ";
      }
      result += ")";
      return result;
  //- Hash::toString( )
  }

} // Hash

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
