/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Keyholder
  Package: impl
  File:    Keyholder.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  Keyholder
  
  Keyholder-field means that the statements apply not to the key, but to 
  the keyholder. Keyholder contains an instance of SpkiPrincipal.
*/
public class Keyholder
  extends Composite {

  /**
  */
  public Keyholder() {
  
  //+ Keyholder::Keyholder( )
    super();
  //- Keyholder::Keyholder( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ Keyholder::check(Component)
      if (!(addition instanceof SpkiPrincipal))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- Keyholder::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Keyholder::accept(Visitor)
    visitor.at(this);
  //- Keyholder::accept(Visitor)
  }
    
} // Keyholder

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
