/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Name
  Package: impl
  File:    Name.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  Name
  
  The Fully Qualified Name of an issuer or a subject. Contains a Key 
  followed by a one or more ByteStrings (the name sequence). The Key may be
   omitted, in which case the names are relative to Issuer.
*/
public class Name
  extends Composite {

  /**
  */
  public Name() {
  
  //+ Name::Name( )
    super();
  //- Name::Name( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ Name::check(Component)
      if (!(addition instanceof SpkiPrincipal) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if ((addition instanceof SpkiPrincipal) &&
	  (children.size() != 0))
	throw new IllegalStateException();
      return true;
  //- Name::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Name::accept(Visitor)
    visitor.at(this);
  //- Name::accept(Visitor)
  }
  
} // Name

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
