/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SExpr
  Package: impl
  File:    SExpr.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.*;

/**
  SExpr
  
  S-Expression consists of a ByteString followed by an arbitrary number of 
  SParts.
*/
public class SExpr
  extends Composite {

  /**
  */
  public SExpr() {
  
  //+ SExpr::SExpr( )
      super();
  //- SExpr::SExpr( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ SExpr::check(Component)
      if (!(addition instanceof SPart) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if ((addition instanceof ByteString) &&
	  (children.size() == 0))
	return true;
      if ((addition instanceof SPart) &&
	  (children.size() != 0))
	return true;
      throw new IllegalStateException("Children: " + children.size());
  //- SExpr::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ SExpr::accept(Visitor)
    visitor.at(this);
  //- SExpr::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ SExpr::toString( )
    String result = new String("(");
    for (int i = 0; i < size(); i++) {
      result += children.elementAt(i).toString();
      if (i < (size() - 1))
	result += " ";
    }
    result += ")";
    return result;
  //- SExpr::toString( )
  }
  
} // SExpr

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
