/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  TagSimple
  Package: impl
  File:    TagSimple.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  TagSimple
  
  Defines a tag starting with a bytestring.
*/
public class TagSimple
  extends Composite {

  /**
  */
  public TagSimple() {
  
  //+ TagSimple::TagSimple( )
    super();
  //- TagSimple::TagSimple( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ TagSimple::check(Component)
      if (!(addition instanceof TagExpr) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if ((addition instanceof ByteString) &&
	  (children.size() == 0))
	return true;
      if ((addition instanceof TagExpr) &&
	  (children.size() != 0))
	return true;
      throw new IllegalStateException();
  //- TagSimple::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ TagSimple::accept(Visitor)
      visitor.at(this);
  //- TagSimple::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ TagSimple::toString( )
    String result = new String("(" + get(0).toString() + " " + get(1).toString());
    for (int i = 2; i < size(); i++)
      result = new String(result + " " + get(i).toString());
    result += ")";
    return result;
  //- TagSimple::toString( )
  }
  
} // TagSimple

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
