/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  ThresholdSubj
  Package: impl
  File:    ThresholdSubj.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  ThresholdSubj
  
  Threshold-subject defines N subjects, K of which are needed to get the 
  authority. It contains a KVal and one or more Subjects.
*/
public class ThresholdSubj
  extends Composite {

  /**
  */
  public ThresholdSubj() {
  
  //+ ThresholdSubj::ThresholdSubj( )
    super();
  //- ThresholdSubj::ThresholdSubj( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ ThresholdSubj::check(Component)
      if (!(addition instanceof Subject) &&
	  !(addition instanceof KVal))
	return false;
      if ((children.size() == 0) &&
	  (addition instanceof Subject))
	throw new IllegalStateException();
      if ((children.size() > 0) &&
	  (addition instanceof KVal))
	throw new IllegalStateException();
      return true;
  //- ThresholdSubj::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ ThresholdSubj::accept(Visitor)
      visitor.at(this);
  //- ThresholdSubj::accept(Visitor)
  }
  
} // ThresholdSubj

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
