import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.impl.*;
import fi.hut.tcm.policy.*;
import fi.hut.tcm.repository.*;
import java.security.Security;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.KeyStore;
import java.security.PublicKey;
import java.security.PrivateKey;
import java.security.Provider;
import java.security.Policy;
import java.security.CodeSource;
import java.security.PermissionCollection;
import java.security.cert.*;
import java.net.URL;
import java.io.*;
import sun.security.util.PropertyExpander;
import java.util.*;

class testi3 {

  public final static void main(String[] args) throws Exception {

    System.out.println("Testing the CertificateRepository");

    KeyStore ks = KeyStore.getInstance("JKS");
    PublicKey key = null;
    String alias = "Admin";
    SPKICertificateRepository cr = SPKICertificateRepository.getInstance();

    System.out.println("* Fetching keys...");
    String ksfile = new String(PropertyExpander.expand("${user.home}/.keystore"));
    ks.load(new FileInputStream(ksfile), "passwd".toCharArray());
    if (ks.containsAlias(alias)) {
      java.security.cert.Certificate certif = ks.getCertificate(alias);
      key = certif.getPublicKey();
    } else {
      throw new Exception("No such alias: " + alias);
    }
    System.out.println("Key: " + key.toString());

    System.out.println("* Fetching corresponding certificates...");
    cr.load();
    Vector v = cr.getCertsBySubject(new Subject(key));
    SPKICertificate c = null;
    if (v.size() == 0)
      System.out.println("No certificates");
    else {
      Iterator i = v.iterator();
      while (i.hasNext()) {
	c = (SPKICertificate) i.next();
	System.out.println("Cert: " + c.toString());
      }
    }
    
    System.out.println("More tests...");
    Issuer issuer = new Issuer(c.getIssuer());
    System.out.println(issuer.toString());
    v = cr.getCertsByIssuer(issuer);
    if (v.size() == 0)
      System.out.println("No certificates");
    else {
      Iterator i = v.iterator();
      while (i.hasNext()) {
	c = (SPKICertificate) i.next();
	System.out.println("Cert: " + c.toString());
      }
      if (c.getDeleg())
	System.out.println("Delegation ok");
    }
  }
  
}
